﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcApplication1.Models;
using Infragistics.Web.Mvc;

namespace MvcApplication1.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            ViewBag.combo = new List<Models.ComboModel>();
            ViewBag.combo.Add( new Models.ComboModel() { id = 0, isShipping = "No" });
            ViewBag.combo.Add(new Models.ComboModel() { id = 1, isShipping = "Yes" });
            return View();
        }

        private GridModel GetModel()
        {
            GridModel model = new GridModel();
            model.AutoGenerateColumns = false;
            model.PrimaryKey = "MerchantID";
            model.AutoCommit = true;

            GridColumn id = new GridColumn();
            id.Key = "MerchantID";
            id.HeaderText = "Merchant ID";
            id.DataType = "number";

            GridColumn desc = new GridColumn();
            desc.Key = "Merchant Description";
            desc.HeaderText = "Description";
            desc.DataType = "string";

            GridColumn date = new GridColumn();
            date.Key = "Date";
            date.HeaderText = "Shipping Date";
            date.DataType = "date";

            GridColumn isShipping = new GridColumn();
            isShipping.Key = "IsShipping";
            isShipping.HeaderText = "Worldwide Shipping";
            isShipping.DataType = "string";

            model.Columns.Add(id);
            model.Columns.Add(desc);
            model.Columns.Add(date);
            model.Columns.Add(isShipping);
            model.DataSourceUrl = "/Home/GetTestItemList";

            GridGroupBy groupBy = new GridGroupBy();

            GroupByGroupSummaries grSum = new GroupByGroupSummaries(new List<GroupByGroupSummary>() { new GroupByGroupSummary() { SummaryFunction = "Max" } });          
            groupBy.GroupSummaries = grSum;
            groupBy.Type = OpType.Remote;

            GridSummaries summaries = new GridSummaries();
            model.Features.Add(summaries);
            return model;
        }

        [GridDataSourceAction]
        public ActionResult GetTestItemList()
        {
            return View(GetList().AsQueryable());
        }

        private List<TestItem> GetList()
        {
            return new List<TestItem>()
			{
			    new TestItem() {MerchantID = 1, Description = "Merchant 1", Date= new DateTime(2017, 3, 24, 0,0,0, DateTimeKind.Utc), IsShipping=1},
				new TestItem() {MerchantID = 2, Description = "Merchant 2", Date=DateTime.Now, IsShipping=1},
				new TestItem() {MerchantID = 3, Description = "Merchant 3", Date=new DateTime(2017, 12, 10, 0,0,0, DateTimeKind.Utc), IsShipping=0},
                new TestItem() {MerchantID = 4, Description = "Merchant 4", Date=DateTime.Now, IsShipping=1},
                new TestItem() {MerchantID = 5, Description = "Merchant 5", Date=new DateTime(2017, 6, 4, 0,0,0, DateTimeKind.Utc), IsShipping=1},
                new TestItem() {MerchantID = 6, Description = "Merchant 6", Date=new DateTime(2017, 8, 13, 0,0,0, DateTimeKind.Utc), IsShipping=0},
                new TestItem() {MerchantID = 7, Description = "Merchant 7", Date=new DateTime(2017, 3, 24, 0,0,0, DateTimeKind.Utc), IsShipping=1},
                new TestItem() {MerchantID = 8, Description = "Merchant 8", Date=new DateTime(2017, 3, 24, 0,0,0, DateTimeKind.Utc), IsShipping=0},
                new TestItem() {MerchantID = 9, Description = "Merchant 9", Date=new DateTime(2017, 12, 10, 0,0,0, DateTimeKind.Utc), IsShipping=0},
                new TestItem() {MerchantID = 10, Description = "Merchant 10", Date=new DateTime(2017, 9, 28, 0,0,0, DateTimeKind.Utc), IsShipping=0},  
			};
        }
    }
}
